"use strict";

/**
 * Try 对象
 */
var Try = {
  /**
   * 接收任意数目的函数作为参数，返回第一个执行成功的函数（未抛出异常的函数）的结果
   *
   * @return 任意函数参数执行结果
   */
  these: function these() {
    var result;
    for (var i = 0; i < arguments.length; i++) {
      var lambda = arguments[i];
      if (Object.isFunction(lambda)) {
        try {
          result = lambda();
          break;
        } catch (e) {
          console.error(e);
        }
      }
    }
    return result;
  }
};
window.Try = Try;