"use strict";

/**
 * Math 对象扩展
 */
/**
 * 产生一个指定范围内的随机数
 *
 * @param min 返回的最低值(默认 0)
 * @param max 返回的最高值
 * @return 随机数
 */
Math.rand = function (min, max) {
  min = min || 0;
  max = max || Number.MAX_SAFE_INTEGER;
  var rand = Math.random() * (max - min + 1) + min;
  var result = Math.round(rand);
  if (result < min) {
    return min;
  } else if (result > max) {
    return max;
  } else {
    return result;
  }
};